/*---------------------------------------------------------------------------
  This code is part of the book
  LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
  Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
  Hellenic Academic On-line Publications, 2015
----------------------------------------------------------------------------*/

expand(state(Description,Path),NextStates):-
    findall(state(NewDescription,[Description|Path]),
		(operator(state(Description,Path),state(NewDescription,[Description|Path])),
	        not(member(NewDescription,[Description|Path]))),
	NextStates).

dfs:-
    initial_state(S),
    dfs([S],[],Solution),
    write(Solution),nl.

dfs([State|_],_ClosedSet,State):-
    final_state(State).

dfs([State|RestOpen],ClosedSet,Solution):-
    expand(State,NextStates),
    append(NextStates,RestOpen,NewOpenList),
    !,
    dfs(NewOpenList,[State|ClosedSet],Solution).
    
    
  % ?????? ?at?stas?
  initial_state(state((0,0),[])).   
  
  % ?e????? ?atast?se??
  final_state(state((_,40),_Path)).                    
  final_state(state((40,_),_Path)).
              

glassA(70).
glassB(50).
            
% ?de?ase ??? t? pe??e??e?? t?? ? st? ?
operator(state((V1,V2),Path),state((Vsum,0),[(V1,V2)|Path])) :- 
         V2 > 0,
         Vsum is V1 + V2,
     glassA(G1),
      Vsum =< G1.

% ?de?ase ??? t? pe??e??e?? t?? ? st? ?
operator(state((V1,V2),Path),state((0,Vsum),[(V1,V2)|Path])) :- 
         V1 > 0,
         Vsum is V1 + V2,
         glassB(G2),
         Vsum =< G2.

% ?de?ase ???? t?? ? st? ? ??a ?a ?e?se?
operator(state((V1,V2),Path),state((G1,Vdiff),[(V1,V2)|Path])) :-
     V2 > 0,
      V1 >= 0,
      glassA(G1),
      Vdiff is V2 - ( G1 - V1 ),
      Vdiff > 0.

% ?de?ase ???? t?? ? st? ? ??a ?a ?e?se?
operator(state((V1,V2),Path),state((Vdiff,G2),[(V1,V2)|Path])) :-
     V1 > 0,
      V2 >= 0,
      glassB(G2),
      Vdiff is V1 - ( G2 - V2 ),
      Vdiff > 0.

% ???se t? ? ap? t? ??s?
operator(state((V1,V2),Path),state((G1,V2),[(V1,V2)|Path])) :-     
        glassA(G1), V1\=G1.

% ???se t? ? ap? t? ??s?
operator(state((V1,V2),Path),state((V1,G2),[(V1,V2)|Path])) :-         
        glassB(G2), V2\=G2.

% ?de?ase t? ?
operator(state((V1,V2),Path),state((0,V2),[(V1,V2)|Path])).                 

% ?de?ase t? ?
operator(state((V1,V2),Path),state((V1,0),[(V1,V2)|Path])).    

bfs:-
    initial_state(S),
    bfs([S],[],Solution),
    write(Solution),nl.

bfs([State|_],_ClosedSet,State):-
    final_state(State).

bfs([State|RestOpen],ClosedSet,Solution):-
    expand(State,NextStates),
    append(RestOpen, NextStates,NewOpenList),
    !,
    bfs(NewOpenList,[State|ClosedSet],Solution).
